local Scalar = select(2, ...)
local Scalar = LibStub("AceAddon-3.0"):NewAddon(Scalar,"Scalar", "AceConsole-3.0","AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
Scalar.version = GetAddOnMetadata("Scalar", "Version")

Scalar.FrameShown = false

local savedDBDefaults = { --- Default the saved variables
	global = {
		BagScale = 1.0,
		BankScale = 1.0
	},
}

Scalar:RegisterChatCommand("Scalar", "LoadGUI")


function Scalar:OnInitialize()	
	Scalar.db = LibStub:GetLibrary("AceDB-3.0"):New("ScalarDB", savedDBDefaults, true)
	Scalar:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED","ScaleBags")
	Scalar:RegisterEvent("BANKFRAME_OPENED","ScaleBank")
end

function Scalar:LoadGUI()
	if  Scalar.FrameShown == false then
		Scalar.FrameShown = true
		
		Scalar.frame = AceGUI:Create("Frame")
		Scalar.frame:SetTitle("Scalar")
		Scalar.frame:SetStatusText("Scalar version "..Scalar.version)
		Scalar.frame:EnableResize(false)
		Scalar.frame:SetWidth(350)
		Scalar.frame:SetHeight(300)
		Scalar.frame:SetLayout("List")
		Scalar.frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) Scalar.FrameShown = false end)
		
		
		Scalar.BagScaleSlider = AceGUI:Create("Slider")
		Scalar.BagScaleSlider:SetLabel("Bag Scale(on combat log event)")
		Scalar.BagScaleSlider:SetValue(Scalar.db.global.BagScale)
		Scalar.BagScaleSlider:SetSliderValues(0.1, 2.0, 0.1)
		Scalar.BagScaleSlider:SetCallback("OnValueChanged", function(value)
			Scalar:RunUpdateSV()
			Scalar:ScaleBags()
		end)
		Scalar.frame:AddChild(Scalar.BagScaleSlider)
		
		Scalar.BankScaleSlider = AceGUI:Create("Slider")
		Scalar.BankScaleSlider:SetLabel("Bank Scale")
		Scalar.BankScaleSlider:SetValue(Scalar.db.global.BankScale)
		Scalar.BankScaleSlider:SetSliderValues(0.1, 2.0, 0.1)
		Scalar.BankScaleSlider:SetCallback("OnValueChanged", function(value)
			Scalar:RunUpdateSV()
			Scalar:ScaleBank()
		end)
		Scalar.frame:AddChild(Scalar.BankScaleSlider)
		
	elseif Scalar.FrameShown == true then
		Scalar.FrameShown = false
		AceGUI:Release(Scalar.frame)
	end
end

function Scalar:RunUpdateSV()
	Scalar.db.global.BagScale = Scalar.BagScaleSlider:GetValue()
	Scalar.db.global.BankScale = Scalar.BankScaleSlider:GetValue()
end

function Scalar:ScaleBags()
        for i=1, 13 do
                local frame = _G["ContainerFrame"..i]
                frame:SetScale(Scalar.db.global.BagScale)
        end
end

function Scalar:ScaleBank()
	if(BankFrame and  BankFrame:IsShown())  then
                BankFrame:SetScale(Scalar.db.global.BankScale)
        end
end